diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/feed.c tin-2.6.5/src/feed.c
--- tin-2.6.4/src/feed.c	2024-12-04 20:10:52.000000000 +0100
+++ tin-2.6.5/src/feed.c	2025-12-09 04:46:38.432221341 +0100
@@ -3,10 +3,10 @@
  *  Module    : feed.c
  *  Author    : I. Lea
  *  Created   : 1991-08-31
- *  Updated   : 2024-12-04
+ *  Updated   : 2025-12-08
  *  Notes     : provides same interface to mail,pipe,print,save & repost commands
  *
- * Copyright (c) 1991-2025 Iain Lea <iain@bricbrac.de>
+ * Copyright (c) 1991-2026 Iain Lea <iain@bricbrac.de>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -69,7 +69,7 @@ struct t_counters {
 static char *get_save_filename(const struct t_group *group, int function, char *filename, int filelen);
 static t_bool expand_feed_filename(char *outpath, size_t outpath_len, const char *path);
 static t_bool feed_article(int art, int function, struct t_counters *counter, t_bool use_current, const char *data, const struct t_group *group);
-static t_function get_feed_key(int function, int level, struct t_art_stat *thread);
+static t_function get_feed_key(int function, int level, const struct t_art_stat *thread);
 static t_function get_post_proc_type(void);
 static void print_save_summary(t_function type, int fed);
 #ifndef DISABLE_PRINTING
@@ -230,7 +230,7 @@ static t_function
 get_feed_key(
 	int function,
 	int level,
-	struct t_art_stat *thread)
+	const struct t_art_stat *thread)
 {
 	constext *prompt;
 	t_function default_func, func;
@@ -350,6 +350,8 @@ get_feed_key(
  * Print a message like:
  * -- [Article|Thread|Tagged Articles] saved to [mailbox] [filenames] --
  * 'fed' is the number of articles we tried to save
+ *
+ * FIXME: translatable/plural-forms and fixed length buffer
  */
 static void
 print_save_summary(
@@ -360,15 +362,15 @@ print_save_summary(
 	char what[LEN];
 
 	if (fed != num_save)
-		wait_message(2, _(txt_warn_not_all_arts_saved), fed, num_save);
+		wait_message(2, P_(txt_warn_not_all_arts_saved_sp[0], txt_warn_not_all_arts_saved_sp[1], num_save), fed, num_save);
 
 	switch (type) {
 		case FEED_HOT:
-			snprintf(what, sizeof(what), _(txt_prefix_hot), PLURAL(fed, txt_article));
+			snprintf(what, sizeof(what), "%s", P_(txt_hot_article_sp[0], txt_hot_article_sp[1], fed));
 			break;
 
 		case FEED_TAGGED:
-			snprintf(what, sizeof(what), _(txt_prefix_tagged), PLURAL(fed, txt_article));
+			snprintf(what, sizeof(what), "%s", P_(txt_tagged_article_sp[0], txt_tagged_article_sp[1], fed));
 			break;
 
 		case FEED_THREAD:
@@ -378,13 +380,14 @@ print_save_summary(
 		case FEED_ARTICLE:
 		case FEED_PATTERN:
 		default:
-			snprintf(what, sizeof(what), "%s", PLURAL(fed, txt_article));
+			snprintf(what, sizeof(what), "%s", P_(txt_article_sp[0], txt_article_sp[1], fed));
 			break;
 	}
 
 	/*
 	 * We report the range of saved-to files for regular saves of > 1 articles
 	 */
+	/* FIXME: translatable/plural-forms */
 	if (num_save == 1 || save[0].mailbox)
 		snprintf(buf, sizeof(buf), _(txt_saved_to),
 			what, (save[0].mailbox ? _(txt_mailbox) : ""), save[0].path);
@@ -443,6 +446,9 @@ feed_article(
 		case FEED_AUTOSAVE:
 			progress_mesg = fmt_string("%s (%d/%d)", _(txt_saving), counter->total, counter->max);
 			break;
+
+		default:
+			break;
 	}
 
 	if (progress_mesg != NULL) {
@@ -567,7 +573,7 @@ feed_articles(
 	int function,
 	int level,
 	t_function type,
-	struct t_group *group,
+	const struct t_group *group,
 	int respnum)
 {
 	char *prompt;
@@ -624,7 +630,7 @@ feed_articles(
 	 */
 	switch (function) {
 		/* Setup mail - get address to mail to */
-		case FEED_MAIL:
+		case FEED_MAIL: /* FIXME: translatable/plural-forms */
 			prompt = fmt_string(_(txt_mail_art_to), cCOLS - (strwidth(_(txt_mail_art_to)) > cCOLS - 30 ? cCOLS - 30 : strwidth(_(txt_mail_art_to)) + 30), tinrc.default_mail_address);
 			if (!(prompt_string_ptr_default(prompt, &tinrc.default_mail_address, _(txt_no_mail_address), HIST_MAIL_ADDRESS))) {
 				free(prompt);
@@ -663,7 +669,7 @@ feed_articles(
 		/* FIXME: don't use fixed length buffer */
 		case FEED_PRINT:
 			{
-				int l = sizeof(outpath) - strlen(tinrc.printer) - strlen(REDIRECT_OUTPUT) - 2;
+				int l = (int) (sizeof(outpath) - strlen(tinrc.printer) - strlen(REDIRECT_OUTPUT) - 2);
 
 				if (l > 0)
 					snprintf(outpath, sizeof(outpath), "%.*s %s", l, tinrc.printer, REDIRECT_OUTPUT);
@@ -723,10 +729,9 @@ feed_articles(
 				char *tmp;
 				char *smsg;
 #ifndef FORGERY
-				char from_name[PATH_LEN];
-
-				get_from_name(from_name, (struct t_group *) 0);
+				char from_name[HEADER_LEN];
 
+				get_from_name(from_name, sizeof(from_name), (const struct t_group *) 0);
 				if (strstr(from_name, arts[respnum].mailbox.from)) {
 #endif /* !FORGERY */
 					char buf[LEN];
@@ -745,12 +750,12 @@ feed_articles(
 					free(smsg);
 
 					switch (func) {
-						case FEED_SUPERSEDE:
+						case FEED_SUPERSEDE: /* TODO: plural-forms? strip_double_ngs()? */
 							tmp = fmt_string(_(txt_supersede_group), BlankIfNull(tinrc.default_repost_group));
 							supersede = TRUE;
 							break;
 
-						case FEED_KEY_REPOST:
+						case FEED_KEY_REPOST: /* TODO: plural-forms? strip_double_ngs()? */
 							tmp = fmt_string(_(txt_repost_group), BlankIfNull(tinrc.default_repost_group));
 							supersede = FALSE;
 							break;
@@ -760,7 +765,7 @@ feed_articles(
 							return -1;
 					}
 #ifndef FORGERY
-				} else {
+				} else { /* TODO: plural-forms? strip_double_ngs()? */
 					tmp = fmt_string(_(txt_repost_group), BlankIfNull(tinrc.default_repost_group));
 					supersede = FALSE;
 				}
@@ -884,8 +889,8 @@ feed_articles(
 				for_each_art_in_thread(art, i) {
 					if (!arts[art].matched)
 						continue;
-					arts[art].matched = FALSE;
 
+					arts[art].matched = FALSE;
 					/* Keep going - don't abort on errors */
 					if (feed_article(art, function, &counter, use_current, outpath, group)) {
 						if (feed_type == FEED_HOT)
@@ -1013,7 +1018,7 @@ got_epipe_while_piping:
 			if (tinrc.interactive_mailer != INTERACTIVE_NONE)
 				info_message(_(txt_external_mail_done));
 			else
-				info_message(_(txt_articles_mailed), counter.success, PLURAL(counter.success, txt_article));
+				info_message(P_(txt_article_mailed_sp[0], txt_article_mailed_sp[1], counter.success), counter.success);
 			break;
 
 		case FEED_MARK_READ:
@@ -1022,16 +1027,26 @@ got_epipe_while_piping:
 				info_message(_(txt_no_next_unread_art));
 			else {
 				if (counter.success && level != PAGE_LEVEL) {
-					const char *ptr;
+					switch (feed_type) {
+						case FEED_THREAD:
+							info_message((function == FEED_MARK_READ) ?
+								_(txt_marked_thread_as_read) :
+								_(txt_marked_thread_as_unread));
+							break;
 
-					ptr = function == FEED_MARK_READ ? _(txt_marked_as_read) : _(txt_marked_as_unread);
-					if (feed_type == FEED_THREAD) {
-						info_message(ptr, _(txt_thread_upper));
-					} else if (feed_type == FEED_ARTICLE) {
-						info_message(ptr, _(txt_article_upper));
-					} else {
-						ptr = function == FEED_MARK_READ ? _(txt_marked_arts_as_read) : _(txt_marked_arts_as_unread);
-						info_message(ptr, counter.success, counter.max, PLURAL(counter.max, txt_article));
+						case FEED_ARTICLE:
+							info_message((function == FEED_MARK_READ) ?
+								_(txt_marked_article_as_read) :
+								_(txt_marked_article_as_unread));
+							break;
+
+						default:
+							/* FIXME: translatable/plural-forms */
+							info_message((function == FEED_MARK_READ) ?
+								_(txt_marked_arts_as_read) :
+								_(txt_marked_arts_as_unread),
+								counter.success, counter.max, P_(txt_article_sp[0], txt_article_sp[1], counter.max));
+							break;
 					}
 				}
 			}
@@ -1039,13 +1054,13 @@ got_epipe_while_piping:
 
 #ifndef DONT_HAVE_PIPING
 		case FEED_PIPE:
-			info_message(_(txt_articles_piped), counter.success, PLURAL(counter.success, txt_article), tinrc.default_pipe_command);
+			info_message(P_(txt_article_piped_sp[0], txt_article_piped_sp[1], counter.success), counter.success, tinrc.default_pipe_command);
 			break;
 #endif /* !DONT_HAVE_PIPING */
 
 #ifndef DISABLE_PRINTING
 		case FEED_PRINT:
-			info_message(_(txt_articles_printed), counter.success, PLURAL(counter.success, txt_article));
+			info_message(P_(txt_article_printed_sp[0], txt_article_printed_sp[1], counter.success), counter.success);
 			break;
 #endif /* !DISABLE_PRINTING */
 
